import os
path1=os.path.abspath('.')  
import torch
from Sample.neighbor_sampler import NeighborSampler
from part.Utils import GraphData
from DistGraphLoader import DistGraphData
from DistGraphLoader import DistributedDataLoader
from torch_geometric.data import Data
import distparser
from DistCustomPool import CustomPool
import DistCustomPool
from torch.distributed import rpc
from torch.distributed.rpc import RRef, rpc_async, remote
from torch.distributed.rpc import TensorPipeRpcBackendOptions
import time
"""
test command 
python test.py --world_size 2 --rank 0 
--world_size', default=4, type=int, metavar='W',
                    help='number of workers')
parser.add_argument('--rank', default=0, type=int, metavar='W',
                    help='rank of the worker')
parser.add_argument('--log_interval', type=int, default=10, metavar='N',
                    help='interval between training status logs')
parser.add_argument('--gamma', type=float, default=0.99, metavar='G',
                    help='how much to value future rewards')
parser.add_argument('--seed', type=int, default=1, metavar='S',
                    help='random seed  for reproducibility')
parser.add_argument('--num_sampler', type=int, default=10, metavar='S',
                    help='number of samplers')
parser.add_argument('--queue_size', type=int, default=10, metavar='S',
                    help='sampler queue size')
"""
graph =   DistGraphData('/home/sxx/zlj/rpc_ps/part/metis_2')
def _get_local_attr(nodes):
    print('start time',time.time())
    x= graph.select_attr(nodes)
    print('end',time.time())
    return x
if __name__ == "__main__":
    #rank = distparser._get_worker_rank()

    #rpc_backend_options = TensorPipeRpcBackendOptions()
    #rpc_backend_options.init_method = "tcp://{}:{}".format('127.0.0.1',10001)
    #rpc_backend_options.num_worker_threads = 128
    #rpc.init_rpc(
    #        distparser.RPC_NAME.format(rank),
    #        rank=rank,
    #        world_size=2,
    #        rpc_backend_options=rpc_backend_options
    #    )
    
    #print(time.time())
    #start = time.time()
    #if(rank == 0):
    #    fut = rpc_async(
    #        distparser.RPC_NAME.format(1),
    #        _get_local_attr,
    #        args=(torch.arange(graph.partptr[2]-graph.partptr[1]),)
    #    )
    #    while(fut.done() is False):
    #        pass
    #    print(fut.value())
    #    print(time.time()-start,time.time())
    #rpc.shutdown()
    #graph.num_nodes = 3
    #graph.num_edges = 4
    #graph.edge_index = torch.tensor([0,0,1,2],[1,2,2,1])
    #graph.partition_id = torch.tensor([0,2,3])
    #self.partition_id = id
        # 总分区数
    #    self.partitions
    DistCustomPool.init_distribution('127.0.0.1',9663,'127.0.0.1',10001)
    sampler=NeighborSampler(edge_index=graph.edge_index, num_nodes=graph.num_nodes, num_layers=2, workers=2, fanout=[10, 2])
    loader = DistributedDataLoader('test',graph,None,sampler = sampler,batch_size = 2000)
    loader2 = DistributedDataLoader('test2',graph,graph.data.train_mask,sampler = sampler,batch_size = 2000)
    
    for batch_data in(loader):
        for batch_data2 in(loader2):
            print(batch_data.__repr__)

    DistCustomPool.close_distribution()